package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.hr.frame.persistence.BaseDAOManager;
import nc.hr.utils.PubEnv;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.hr.frame.state.StateRegister;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.ValidationException;
import nc.vo.trade.pub.IBillStatus;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;
import u8c.ui.mmpac.datamodel.OrderDataModel;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;

public class OrderApproveAction extends AbstractAction{
	OrderTestUI frameUI = null;
	BaseDAOManager dao = new BaseDAOManager();

	public OrderApproveAction(FrameUI frameUI) {
		super(frameUI);
		this.frameUI = (OrderTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		//int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		//HRAggVO [] s = (HRAggVO[]) mainMgrPanel.getMainBillListPanel().getData();
	//	HRAggVO [] s = new HRAggVO[] {this.getSelection(mainMgrPanel)};
		
		boolean boo = this.frameUI.getBillCardPanel().isShowing();
		HRAggVO [] s = null;
		if(boo) {
			HRAggVO	aggvo=(HRAggVO) mainMgrPanel.getMainBillCardPanel().getDeleteData();
			s=new HRAggVO[]{aggvo};
		}else {
			s=(HRAggVO[]) mainMgrPanel.getMainBillListPanel().getDeleteData();
		}
		
		if(s != null) {
			for (int i = 0; i < s.length; i++) {
				OrderMainVO headvo = (OrderMainVO) s[i].getParentVO();
				//检查出入库页签数据和材料明细选择条数一样
				
				OrderIssueVO[] issuervos=  (OrderIssueVO[]) s[i].getTableVO("mmpac_order_issue");
				List<OrderIssueVO> execList = new ArrayList<OrderIssueVO>();
				for(OrderIssueVO issuervo:issuervos) {
					Object bdef5 = issuervo.getBdef5();//是否委外
					if(bdef5 != null && bdef5.equals("Y") ) {
						execList.add(issuervo);
					}
				}
				List<OrderOtherinVO> invoslis=new ArrayList<OrderOtherinVO>();
				List<OrderOtheroutVO> outvoslis=new ArrayList<OrderOtheroutVO>();
				
				OrderOtherinVO[] invos=  (OrderOtherinVO[]) s[i].getTableVO("mmpac_order_otherin");
		
				OrderOtheroutVO[] outvos=  (OrderOtheroutVO[]) s[i].getTableVO("mmpac_order_otherout");
				
				if(null!=invos) {
					invoslis=Arrays.asList(invos);
				}
				
				if(null!=outvos) {
					outvoslis=Arrays.asList(outvos);
				}
				
				
				if(execList.size()!=invoslis.size() || execList.size()!=outvoslis.size()) {
				  //	throw new ValidationException("【委外出入库】和【材料明细】所选不一样，请重新生成出入库页签！");
					
				  int answer = MessageDialog.showYesNoDlg(this.frameUI, "提示", "【委外出入库】和【材料明细】选择条数不一样，是否继续？");
				    if (UIDialog.ID_NO == answer) {
				                   return;
				       }
				
				}
				
				
				if (headvo.getBillstatus() != IBillStatus.FREE){
					throw new ValidationException("非自由态单据不允许审批");
				}
				headvo.setBillstatus(IBillStatus.CHECKPASS);
				headvo.setPk_approver(PubEnv.getPk_user());
				((OrderDataModel)this.frameUI.getDataModel()).execApprove(s[i]);
			}
		}

		if(boo) {
			this.frameUI.getBillCardPanel().setBillValueVO(s[0]);//卡片界面就1条数据
		}else {
			getFrameUI().getBtnManager().getCmdByID(AbstractBtnReg.SYSBTN_REFRESH).execute();
		}
		
		
	}
}
