package nc.ui.so.so002;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.ui.pub.bill.BillEditListener2;
import nc.ui.uif2.model.AbstractAppModel;
import nc.vo.pub.lang.UFDouble;
import nc.vo.so.so002.SaleVO;
import nc.vo.so.so002.SaleinvoiceBVO;
import nc.vo.so.so002.SaleinvoiceVO;
import nc.ui.erm.costshare.common.CommonConfirmDialogUtils;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UIButton;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ValidationException;
import nc.ui.pub.beans.MessageDialog;
/**
 * 分摊界面
 *@Description: TODO
 *@Author: ZTH
 *@Date:2023年12月29日 上午9:46:15
 *@Version: V1.0
 */

@SuppressWarnings("deprecation")
public class FtCountDLG extends UIDialog implements BillEditListener {

	/**
	 * 金额分摊
	 */
	private static final long serialVersionUID = -2624122850765833692L;
	/** 确定按钮 */
	private UIButton btnOK;
	/** 取消按钮 */
	private UIButton btnNO;
	/**增行按钮*/
	private UIButton btnAdd;
	/**重新排号*/
	private UIButton btnRrn;
	/**删行按钮*/
	private UIButton btnDel;
	private BillCardPanel jlcardPanel;
	private SaleInvoiceCardPanel ivjBillCardPanel;//销售发票界面
	private ActionHandler actionHandler = new ActionHandler();
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPane2 = null;
	private UIPanel btnUIPanel;
	private UISplitPane splitPane;
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	
	private UIButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new UIButton();
			btnOK.setName("btnOK");
			btnOK.setText("确定(Y)");
		}
		return this.btnOK;
	}

	private UIButton getBtnNO() {
		if (btnNO == null) {
			btnNO = new UIButton();
			btnNO.setName("btnON");
			btnNO.setText("取消(C)");
		}
		return this.btnNO;
	}
	
	
	private UIButton  getBtnDelLine(){
		if (btnDel == null) {
			btnDel = new UIButton();
			btnDel.setName("btnDel");
			btnDel.setText("删行");
		}
		return this.btnDel;
	}
	
	private UIButton  getBtnAddLine(){
		if (btnAdd == null) {
			btnAdd = new UIButton();
			btnAdd.setName("btnAdd");
			btnAdd.setText("增行");
		}
		return this.btnAdd;
	}
	
	private UIButton  getBtnRrnLine(){
		if (btnRrn == null) {
			btnRrn = new UIButton();
			btnRrn.setName("btnRrn");
			btnRrn.setText("重新排号");
		}
		return this.btnRrn;
	}
	
    public FtCountDLG(){
		
		super();
		initialize();
		
	}
    
    
    public FtCountDLG(SaleInvoiceCardPanel ivjBillCardPanel){
		super();
		this.ivjBillCardPanel=ivjBillCardPanel;
		initialize();
		try {
			doAction();
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
    
	/**
	 * 初始化
	 */
	private void initialize() {	
		setLayout(new BorderLayout());
		this.setBounds(200, 150, 650, 350);
		this.setTitle("分摊界面");
		this.setResizable(true);
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPane(), BorderLayout.CENTER);
		add(this.getBtnUIPanel(), BorderLayout.SOUTH);
		// 添加监听
		this.addActionListener();
		
		
		
	}
	
	
	/**
	 * 界面的监听
	 */
	private void addActionListener() {
		// TODO Auto-generated method stub
//	    this.getBtnAddLine().addActionListener(this.actionHandler);
		this.getBtnOK().addActionListener(this.actionHandler);
		this.getBtnNO().addActionListener(this.actionHandler);
//		this.getBtnDelLine().addActionListener(this.actionHandler);
//		this.getBtnRrnLine().addActionListener(this.actionHandler);
		this.getBillCardPanel().addEditListener(this);//编辑后监听
//		this.getBillCardPanel().addBodyEditListener2(this);//编辑前监听
	}
	
	private UIPanel getUIPanel0() {
		if (ivjUIPanel0 == null) {
			try {
				ivjUIPanel0 = new UIPanel();
				ivjUIPanel0.setLayout(new FlowLayout(FlowLayout.LEFT));
//				ivjUIPanel0.add(getTypeLabel());
//				ivjUIPanel0.add(getTypePanel());
//				ivjUIPanel0.add(getBtnAddLine());
//				ivjUIPanel0.add(getBtnDelLine());
//				ivjUIPanel0.add(getBtnRrnLine());
			} catch (Throwable ivjExc) {
			
			}
		}
		return this.ivjUIPanel0;
	}
	

	
	private UIPanel getUIPane() {
		if (ivjUIPane2 == null) {
			ivjUIPane2 = new UIPanel();
			ivjUIPane2.setLayout(new BorderLayout());
			ivjUIPane2.setPreferredSize(new Dimension(0, 500));
			// ivjUIPanel2.add(getTablePanel(), BorderLayout.CENTER);
			ivjUIPane2.add(getUISplitPane(), BorderLayout.CENTER);
		}
		return this.ivjUIPane2;
	}
	
	public UISplitPane getUISplitPane() {
		if (splitPane == null) {
			splitPane = new UISplitPane(UISplitPane.VERTICAL_SPLIT);
			splitPane.setTopComponent(getBillCardPanel());
			// splitPane.setDividerLocation(80);//上间距
			splitPane.setOneTouchExpandable(true);
			splitPane.setDividerSize(3);
		}
		return this.splitPane;
	}
	
	public BillCardPanel getBillCardPanel() {
		if (jlcardPanel == null) {
			jlcardPanel = new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			jlcardPanel.loadTemplet("FT99", null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
	//		billListPanel.setTatolRowShow(true);  //合计
		}
		return this.jlcardPanel;
	}
	

	@Override
	public void afterEdit(BillEditEvent arg0) {
		//手工填的数量不可以大于合计数量
		if("ftnum".equals(arg0.getKey())) {
			int row=arg0.getRow();
			UFDouble ftnum=new UFDouble(arg0.getValue().toString());//手工填的数量
			UFDouble totalnum = new UFDouble(this.getBillCardPanel().getBodyValueAt(row, "totalnum").toString()) ;  //合计数量
			
			if(ftnum.compareTo(totalnum)>0) {
				 MessageDialog.showErrorDlg(this.jlcardPanel, null, "分摊数量不可以大于合计数量！");
				 this.getBillCardPanel().setBodyValueAt(null, row, "ftnum");
				 return;
				
			}
			
		}
		
	}

	@Override
	public void bodyRowChange(BillEditEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	public UIPanel getBtnUIPanel() {
		if (btnUIPanel == null) {
			btnUIPanel = new nc.ui.pub.beans.UIPanel();
			btnUIPanel.add(this.getBtnOK(), this.getBtnOK().getName());
			btnUIPanel.add(this.getBtnNO(), this.getBtnNO().getName());
		}
		return this.btnUIPanel;
	}
	
	class ActionHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			   // 确定按钮执行事件
			if (e.getSource() == FtCountDLG.this.getBtnOK()) {
				
				FtCountDLG.this.doOKAction();
			}
			   // 取消按钮执行事件
			if (e.getSource() == FtCountDLG.this.getBtnNO()) {
				
				FtCountDLG.this.doNOAction();
			}
			   // 增行按钮执行事件
			if (e.getSource() == FtCountDLG.this.getBtnAddLine()) {
				
				FtCountDLG.this.doAddAction();
			}
			
			   // 删行按钮执行事件
			if (e.getSource() == FtCountDLG.this.getBtnDelLine()) {
				
				FtCountDLG.this.doDelAction();
			}
			
			
			   // 重新排号按钮执行事件
			if (e.getSource() == FtCountDLG.this.getBtnRrnLine()) {
				
				FtCountDLG.this.doRrnAction();
			}
			

		}
	}
	
	
    public void  doDelAction() {
  //  	MessageDialog.showHintDlg(null, "提示", "删行啦！！！！！！！！");
    	// 获取选取的行号
		int[] selectedRowNo = this.jlcardPanel.getBillTable()
				.getSelectedRows();
		if (null == selectedRowNo || selectedRowNo.length < 1) {
			String message =
	    	          nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("4012003_0",
	    	              "04012003-0003")/* @res "请选择要删除的材料行" */;
	    	      MessageDialog.showErrorDlg(this.jlcardPanel, null, message);
		}
    
    	
    	this.jlcardPanel.getBillModel().delLine(selectedRowNo);
    	
    }
	
	
	
	
    public void doAddAction() {
    		
      this.jlcardPanel.getBillModel().addLine();
      int rowcount =  this.jlcardPanel .getBillModel().getRowCount();
      for (int i = 0; i <rowcount; i++) {
    	  this.jlcardPanel.setBodyValueAt("" + (i * 10 + 10), i, "row"); 
      }
      
	}
	
	
	public void doRrnAction() {
	  int rowcount = this.jlcardPanel.getBillModel().getRowCount();
      for (int i = 0; i < rowcount; i++) {
         this.jlcardPanel.setBodyValueAt("" + (i * 10 + 10), i,"row");
       }
		
	}
    
	public void doNOAction() {
		if (UIDialog.ID_YES == CommonConfirmDialogUtils
				.showConfirmCancelDialog(ivjBillCardPanel)){
			
			this.dispose();
			
		}
	}
		
	
	public void doOKAction() {
		
	  try {
		  getBillCardPanel().dataNotNullValidate();//非空校验
		} catch (ValidationException e) {
			// TODO 自动生成的 catch 块
			e.printStackTrace();
			String msg="nc.vo.pub.NullFieldException:";
//			ShowStatusBarMsgUtil.showErrorMsgWithClear("提示", e.toString().substring(
//					e.toString().indexOf(msg)+msg.length()), ivjBillCardPanel);
			MessageDialog.showErrorDlg(jlcardPanel, "错误", e.toString().substring(
					e.toString().indexOf(msg)+msg.length()));
		    return;
		}
	  
	  //修改销售发票明细的数量
	  setReturnParam();
	  
	  this.dispose();
	  
	}
	
	
	//根据开票类型合计数量
	
	public void doAction() throws BusinessException{
		Map<String,UFDouble> mapkplx=new HashMap<String,UFDouble>();//主数量
		Map<String,UFDouble> mapkplx2=new HashMap<String,UFDouble>();//辅数量
		for (int i =0;i<this.ivjBillCardPanel.getBillModel().getRowCount(); i++) {
//			this.getBillCardPanel().addLine();
//			int rowcount = this.getBillCardPanel().getBillModel().getRowCount();
//			this.getBillCardPanel().setBodyValueAt(10*(i+1)+"", rowcount - 1, "row");
			String vdef15 = (String) this.ivjBillCardPanel.getBodyValueAt(i, "vdef15");//开票类型
//			this.getBillCardPanel().setBodyValueAt(vdef15, rowcount - 1, "fttype");
			Object nnumberobj = this.ivjBillCardPanel.getBodyValueAt(i, "nnumber");//主数量
			Object npacknumberobj =  this.ivjBillCardPanel.getBodyValueAt(i, "npacknumber");//辅数量
			Object scalefactor=  this.ivjBillCardPanel.getBodyValueAt(i, "scalefactor");//换算率
//			this.getBillCardPanel().setBodyValueAt(nnumber, rowcount - 1, "totalnum");
			
			if(null==mapkplx.get(vdef15)) {
				mapkplx.put(vdef15, new UFDouble(nnumberobj.toString()));
			}else {
				UFDouble newsl=mapkplx.get(vdef15).add(new UFDouble(nnumberobj.toString()));
				mapkplx.put(vdef15, newsl);
			}
			
			if(null!=npacknumberobj) {
				if(null==mapkplx2.get(vdef15)) {
					mapkplx2.put(vdef15, new UFDouble(npacknumberobj.toString()));
				}else {
					UFDouble newsl=mapkplx2.get(vdef15).add(new UFDouble(npacknumberobj.toString()));
					mapkplx2.put(vdef15, newsl);
				}
			}
			
		}
		
		 int i=0;
		 for (Map.Entry<String,UFDouble> entry : mapkplx.entrySet()) {
			 this.getBillCardPanel().addLine();
			 int rowcount = this.getBillCardPanel().getBillModel().getRowCount();
			 this.getBillCardPanel().setBodyValueAt(10*(i+1)+"", rowcount - 1, "row"); 
			 this.getBillCardPanel().setBodyValueAt(entry.getKey(), rowcount - 1, "fttype");//开票类型
			 this.getBillCardPanel().setBodyValueAt(entry.getValue(), rowcount - 1, "totalnum");//合计数量
			 i+=1;
		 }
		
		
	}
	
	
	//修改销售发票明细的数量,set金额
	
	public void setReturnParam() {
		Map<String,UFDouble> mapcount=new HashMap<String,UFDouble>();//记录每个开票类型数量合计，用于分摊金额
		Map<String,UFDouble> mapamount=new HashMap<String,UFDouble>();//记录每个开票类型含税金额
		for (int i =0;i<this.jlcardPanel.getBillModel().getRowCount(); i++) {
		//	MessageDialog.showHintDlg(jlcardPanel, "测",this.jlcardPanel.getBillModel().getRowCount()+"" );
			String fttype=(String) this.jlcardPanel.getBodyValueAt(i, "fttype");//开票类型
			UFDouble amount=(UFDouble) this.jlcardPanel.getBodyValueAt(i, "amount");//客户手工填的【含税金额】
			UFDouble ftnum=(UFDouble) this.jlcardPanel.getBodyValueAt(i, "ftnum");//客户手工填的【分摊数量】
//			UFDouble count=UFDouble.ZERO_DBL;
			mapamount.put(fttype, amount);
			mapcount.put(fttype, ftnum);
			//销售发票列循环
			for (int j =0;j<this.ivjBillCardPanel.getBillModel().getRowCount(); j++) {
				String vdef15 = (String) this.ivjBillCardPanel.getBodyValueAt(j, "vdef15");//开票类型
				Object nnumberobj = this.ivjBillCardPanel.getBodyValueAt(j, "nnumber");//主数量
				
				UFDouble  nnumber=new UFDouble(nnumberobj.toString());//销售发票主数量
				
				//同开票类型
				if(fttype.equals(vdef15)) {
					//手工填的计算后的数量小于销售发票的数量，数量改成手工计算后的数量
					if(ftnum.sub(nnumber).compareTo(UFDouble.ZERO_DBL)<0) {
						this.ivjBillCardPanel.setBodyValueAt(ftnum, j, "nnumber");
						//说明分摊完了还有同开票类型的，就删除这条数据
						if(ftnum.compareTo(UFDouble.ZERO_DBL)==0) {
							int[] selectedRowNo = {j};
							this.ivjBillCardPanel.getBillModel().delLine(selectedRowNo);
						}else {
							//count.add(ftnum);
						}
						ftnum=UFDouble.ZERO_DBL;
					}else {
						//手工填的大于了销售发票明细的数量，就不用改数量，扣减掉明细数量
						ftnum=ftnum.sub(nnumber);
						//count.add(nnumber);
					}
				}
				
			}
		//	mapcount.put(fttype, count);
		}
		
		
		
		//含税金额分摊计算
		
//		MessageDialog.showHintDlg(ivjBillCardPanel, "测",this.ivjBillCardPanel.getBillModel().getRowCount()+"" );
		//数量分摊后的销售发票明细数据
		for (int j =0;j<this.ivjBillCardPanel.getBillModel().getRowCount(); j++) {
			String vdef15 = (String) this.ivjBillCardPanel.getBodyValueAt(j, "vdef15");//开票类型
			Object nnumberobj = this.ivjBillCardPanel.getBodyValueAt(j, "nnumber");//主数量
			UFDouble nnumber=new UFDouble(nnumberobj.toString());
			UFDouble sumcount=mapcount.get(vdef15);//合计数量
			UFDouble summount=mapamount.get(vdef15);//含税金额
			UFDouble bcje=summount.multiply(new UFDouble(nnumberobj.toString()).div(sumcount));//行预分摊含税金额
//			this.ivjBillCardPanel.setBodyValueAt(bcje, j, "noriginalcursummny");//原币价税合计	
//			this.ivjBillCardPanel.setBodyValueAt(bcje, j, "nsummny");//本币价税合计
//			this.ivjBillCardPanel.setBodyValueAt(bcje, j, "nsubsummny");//冲减前原币金额
//			this.ivjBillCardPanel.setBodyValueAt(bcje, j, "nsubcursummny");//冲减前本币金额
			
			//含税单价=行预分摊含税金额/主数量
			UFDouble ntaxprice=bcje.div(nnumber).setScale(2, UFDouble.ROUND_HALF_UP);
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "ntaxprice");//本币含税单价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "noriginalcurtaxprice");//原币含税单价
			
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nquoteoriginalcurtaxprice");//报价单位原币含税单价 
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nquotetaxprice");//报价单位本币含税单价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "noriginalcurtaxnetprice");//原币含税净价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "ntaxnetprice");//本币含税净价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nquotetaxnetprice");//报价单位本币含税净价 
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nquoteoriginalcurtaxnetprice");//报价单位原币含税净价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nsubquotetaxprice");//冲减前报价单位本币含税单价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nsubquotetaxnetprice");//冲减前报价单位本币含税净价
			this.ivjBillCardPanel.setBodyValueAt(ntaxprice, j, "nsubtaxnetprice");//冲减前主计量单位本币含税净价
			
			//不含税单价=含税单价/(1+13%)
			UFDouble wsmny=ntaxprice.div(new UFDouble("1.13")).setScale(2, UFDouble.ROUND_HALF_UP);
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nprice");//本币无税单价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "noriginalcurprice");//原币无税单价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquoteoriginalcurprice");//报价单位原币无税单价 
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquoteprice");//报价单位本币无税单价  
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nnetprice");//本币无税净价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquoteoriginalcurnetprice");//报价单位原币无税净价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquotenetprice");//报价单位本币无税净价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "noriginalcurnetprice");//原币无税净价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquotenetprice");//报价单位本币无税净价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nquoteprice");//报价单位本币无税单价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nsubquoteprice");//冲减前报价单位本币无税单价
			this.ivjBillCardPanel.setBodyValueAt(wsmny, j, "nsubquotenetprice");//冲减前报价单位本币无税净价

			
			UFDouble noriginalcursummny=ntaxprice.multiply(nnumber).setScale(2, UFDouble.ROUND_HALF_UP);
			
			this.ivjBillCardPanel.setBodyValueAt(noriginalcursummny, j, "noriginalcursummny");//原币价税合计	
			this.ivjBillCardPanel.setBodyValueAt(noriginalcursummny, j, "nsummny");//本币价税合计			
			this.ivjBillCardPanel.setBodyValueAt(noriginalcursummny, j, "nsubsummny");//冲减前原币金额
			this.ivjBillCardPanel.setBodyValueAt(noriginalcursummny, j, "nsubcursummny");//冲减前本币金额
			
			UFDouble wsje= ntaxprice.div(new UFDouble("1.13")).multiply(nnumber).setScale(2, UFDouble.ROUND_HALF_UP);
			this.ivjBillCardPanel.setBodyValueAt(wsje.setScale(2, UFDouble.ROUND_HALF_UP), j, "noriginalcurmny");//原币无税金额
			this.ivjBillCardPanel.setBodyValueAt(wsje.setScale(2, UFDouble.ROUND_HALF_UP), j, "nmny");//本币无税金额
			
			//税额=价税合计-无税金额(不含税单价*数量)
			UFDouble se=noriginalcursummny.sub(wsje.setScale(2, UFDouble.ROUND_HALF_UP));
			this.ivjBillCardPanel.setBodyValueAt(se, j, "noriginalcurtaxmny");//原币税额
			this.ivjBillCardPanel.setBodyValueAt(se, j, "ntaxmny");//本币税额

			
			
			
		}
		
		
		
		
		
		
		
		
		
	}
	

	
}
